{% extends 'base.html.twig' %}

{% block body %}
    <main class='main-content bgc-grey-100'>
        <div id='mainContent'>
            <h1>{{ isEditing ? 'Modifica' : 'Creazione' }} ospite</h1>
            {{ form_start(main_form) }}
            {{ form_errors(main_form) }}
            <div class="mb-3">
                {{ form_label(main_form.lastname) }}
                {{ form_widget(main_form.lastname, {'attr':{'class' : 'form-control'}}) }}
            </div>
            <div class="mb-3">
                {{ form_label(main_form.firstname) }}
                {{ form_widget(main_form.firstname, {'attr':{'class' : 'form-control'}}) }}
            </div>
            <div class="mb-3">
                {{ form_label(main_form.identified_by) }}
                {{ form_widget(main_form.identified_by, {'attr':{'class' : 'form-control'}}) }}
            </div>
            <div class="mb-3">
                {{ form_label(main_form.starting_from) }}
                {{ form_widget(main_form.starting_from, {'attr':{'class' : 'form-control'}}) }}
            </div>
            <div class="mb-3">
                {{ form_label(main_form.ending_to) }}
                {{ form_widget(main_form.ending_to, {'attr':{'class' : 'form-control'}}) }}
            </div>
            {{ form_widget(main_form.submit, {'attr':{'style' : 'display: none'}}) }}
            {{ form_rest(main_form) }}

            {{ form_end(main_form) }}

            <div class="row sendBtnArea mt-5">
                <div class="col-lg-3 mb-2 d-grid gap-2 d-lg-flex align-items-center">
                    <label for="{{ main_form.submit.vars.id }}"
                           class="btn btn-success">{{ main_form.submit.vars.label }}</label>
                </div>
                <div class="col-lg-6 mb-2 d-grid gap-2 d-lg-flex align-items-center justify-content-lg-center">
                    {% if isEditing %}
                        {{ include('guest/_print.html.twig') }}
                        <button class="btn btn-dark sendCredentialToEmail" data-userid="{{ entity.id }}"
                                data-userfullname="{{ entity.lastname }} {{ entity.firstname }}">Invia per Email
                        </button>
                    {% endif %}
                    <a href="{{ path('guest') }}" class="btn btn-info">
                        Ritorna alla lista
                    </a>
                </div>
                <div class="col-lg-3 mb-2 d-grid gap-2 d-lg-flex align-items-center justify-content-lg-end">
                    {% if isEditing %}
                        <a href="{{ path('guest_delete', { 'id': entity.id }) }}" class="btn btn-danger" onclick="return confirm('Sei sicuro di voler eliminare questo elemento?')">
                            Elimina
                        </a>
                    {% endif %}
                </div>
            </div>


            <div class="modal fade" id="sendToEmailModal" tabindex="-1" aria-labelledby="exampleModalLabel"
                 aria-hidden="true">
                <div class="modal-dialog">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title" id="exampleModalLabel">Invia credenziali via email</h5>
                            <button type="button" class="btn-close" data-bs-dismiss="modal"
                                    aria-label="Close"></button>
                        </div>
                        <div class="modal-body">
                            <div class="status"></div>
                            Invio credenziali di <b class="userFullName"></b> via email all'indirizzo:<br/>
                            <input type="email" class="form-control" id="sendToEmailField"
                                   placeholder="name@example.com">
                        </div>
                        <div class="modal-footer">
                            <button id="sendToEmailBt" type="button" class="btn btn-primary">Invia</button>
                            <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Chiudi</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </main>
{% endblock %}


{% block javascripts %}
    {{ parent() }}
    <script type="text/javascript">
        $(function ($) {
            var sendToEmailModal = $("#sendToEmailModal");
            var sendToEmailField = $("#sendToEmailField");

            $(".sendCredentialToEmail").click(function (e) {
                e.preventDefault();
                var $bt = $(this);
                if ($bt.data("userid") === undefined || $bt.data("userid") === "" || $bt.data("userfullname") === undefined || $bt.data("userfullname") === "") {
                    return;
                }

                sendToEmailModal.data("userid", $bt.data("userid"));
                var modalContent = sendToEmailModal.children(".modal-dialog").children(".modal-content");
                modalContent.children(".modal-body").children('.userFullName').text($bt.data("userfullname"));
                modalContent.children(".modal-body").children('.status').removeClass('alert').removeClass("alert-danger").removeClass("alert-success").text("");
                $("#sendToEmailField").val("");
                sendToEmailModal.modal("show");
            });

            $("#sendToEmailBt").click(function () {
                if (sendToEmailModal.data("userid") === undefined || sendToEmailModal.data("userid") === "") {
                    return;
                }

                var modalContent = sendToEmailModal.children(".modal-dialog").children(".modal-content");
                var statusArea = modalContent.children(".modal-body").children('.status');
                statusArea.removeClass('alert').removeClass("alert-danger").removeClass("alert-success").text("");

                if (sendToEmailField.val() === "") {
                    statusArea.addClass("alert").addClass("alert-danger").text("E-Mail non valida");
                    return;
                }

                console.log(sendToEmailModal.data("userid"));
                $.get("{{ path("guest_send_credential_to_email",{'id': '%id'}) }}".replace("%25id", sendToEmailModal.data("userid")), {'emailTo': sendToEmailField.val()}, function (data) {
                    if (data.success !== true) {
                        statusArea.addClass("alert").addClass("alert-danger").html('Errore durante l\'elaborazione della richiesta:<br />' + data.error);
                        return;
                    }

                    statusArea.addClass("alert").addClass("alert-success").text('Email inviata correttamente');
                    sendToEmailField.val("");
                }, "json").fail(function (event, jqXHR) {
                    statusArea.addClass("alert").addClass("alert-danger").text('Errore durante l\'elaborazione della richiesta');
                });
            });
        })
    </script>




{% endblock %}
